Index: issm/trunk/src/c/classes/objects/Materials/Matice.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Materials/Matice.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Materials/Matice.cpp	(revision 13975)
@@ -15,5 +15,5 @@
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
-		
+
 /*Matice constructors and destructor*/
 /*FUNCTION Matice::Matice(){{{*/
@@ -28,5 +28,4 @@
 
 	/*Intermediaries:*/
-	int    i;
 	int    matice_eid;
 
@@ -82,10 +81,4 @@
 int    Matice::Id(void){ return mid; }
 /*}}}*/
-/*FUNCTION Matice::MyRank {{{*/
-int    Matice::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Matice::ObjectEnum{{{*/
 int Matice::ObjectEnum(void){
@@ -190,5 +183,5 @@
 			/*Prepare index list*/
 			int doflist1[3];
-			for(int i=0;i<3;i++) doflist1[i]=((Tria*)element)->nodes[i]->GetVertexDof();
+			for(int i=0;i<3;i++) doflist1[i]=((Tria*)element)->nodes[i]->GetVertexPid();
 
 			/*Get input (either in element or material)*/
@@ -283,5 +276,5 @@
 	 * return g, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity3d;
@@ -324,5 +317,5 @@
 			else{
 				e=(n-1)/2/n;
-			
+
 				viscosity3d=B/(2*pow(A,e));
 			}
@@ -353,5 +346,5 @@
 	 * return g, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity3d;
@@ -369,5 +362,5 @@
 	B=GetB();
 	n=GetN();
-	
+
 	if (n==1){
 		/*Viscous behaviour! viscosity3d=B: */
@@ -422,5 +415,5 @@
 	 * return mu20, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity_complement;
@@ -450,5 +443,5 @@
 		else{
 			e=(n-1)/(2*n);
-		
+
 			viscosity_complement=1/(2*pow(A,e));
 		}
@@ -462,5 +455,5 @@
 	_assert_(n>0);
 	_assert_(viscosity_complement>0);
-		
+
 	/*Return: */
 	*pviscosity_complement=viscosity_complement;
@@ -509,5 +502,5 @@
 
 	/*input strain rate: */
-	IssmDouble exx,eyy,exy,exz;
+	IssmDouble exx,eyy,exy;
 
 	/*Get visocisty and n*/
@@ -560,5 +553,5 @@
 				case TriaEnum: {
 					IssmDouble values[3];
-					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetVertexDof()];
+					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetVertexPid()];
 					this->inputs->AddInput(new TriaP1Input(name,values));
 					return;
@@ -602,5 +595,5 @@
 				case TriaEnum: {
 					IssmDouble values[3];
-					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetSidList()]; //use sid list, to index into serial oriented vector 
+					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetVertexSid()]; //index into serial oriented vector 
 					this->inputs->AddInput(new TriaP1Input(name,values));
 					/*Special case for rheology B in 2D: Pourave land for this solution{{{*/
@@ -627,6 +620,4 @@
 	}
 
-
-
 }
 /*}}}*/
Index: issm/trunk/src/c/classes/objects/Materials/Matice.h
===================================================================
--- issm/trunk/src/c/classes/objects/Materials/Matice.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Materials/Matice.h	(revision 13975)
@@ -15,6 +15,6 @@
 
 	private: 
-		int	   mid;
-		Hook* helement;
+		int   mid;
+		Hook *helement;
 
 	public:
@@ -28,5 +28,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Materials/Matpar.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Materials/Matpar.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Materials/Matpar.cpp	(revision 13975)
@@ -15,5 +15,5 @@
 #include "../../../include/include.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-		
+
 /*Matpar constructors and destructor*/
 /*FUNCTION Matpar::Matpar() {{{*/
@@ -39,5 +39,5 @@
 	iomodel->Constant(&this->thermal_exchange_velocity,MaterialsThermalExchangeVelocityEnum);
 	iomodel->Constant(&this->g,ConstantsGEnum);
-	
+
 	iomodel->Constant(&this->hydro_CR,HydrologyCREnum);
 	iomodel->Constant(&this->kn,HydrologyKnEnum);
@@ -85,10 +85,4 @@
 int    Matpar::Id(void){ return mid; }
 /*}}}*/
-/*FUNCTION Matpar::MyRank {{{*/
-int    Matpar::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Matpar::ObjectEnum{{{*/
 int Matpar::ObjectEnum(void){
@@ -250,5 +244,5 @@
 /*FUNCTION Matpar::GetRhoIce {{{*/
 IssmDouble Matpar::GetRhoIce(){
-	
+
 	return rho_ice;
 }
@@ -329,5 +323,5 @@
 	/*Ouput*/
 	IssmDouble temperature,waterfraction;
-	
+
 	if(enthalpy<PureIceEnthalpy(pressure)){
 		temperature=referencetemperature+enthalpy/heatcapacity;
@@ -349,5 +343,5 @@
 	/*Ouput*/
 	IssmDouble enthalpy;
-	
+
 	if(temperature<TMeltingPoint(pressure)){
 		enthalpy=heatcapacity*(temperature-referencetemperature);
Index: issm/trunk/src/c/classes/objects/Materials/Matpar.h
===================================================================
--- issm/trunk/src/c/classes/objects/Materials/Matpar.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Materials/Matpar.h	(revision 13975)
@@ -43,10 +43,9 @@
 
 		/*Object virtual functions definitions:{{{ */
-		void  Echo();
-		void  DeepEcho();
-		int   Id(); 
-		int   MyRank();
-		int   ObjectEnum();
-		Object* copy();
+		void    Echo();
+		void    DeepEcho();
+		int     Id();
+		int     ObjectEnum();
+		Object *copy();
 		/*}}}*/
 		/*Update virtual functions resolution: {{{*/
Index: issm/trunk/src/c/classes/objects/Node.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Node.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Node.cpp	(revision 13975)
@@ -58,11 +58,11 @@
 	this->inputs=new Inputs();
 	if (iomodel->Data(MeshVertexonbedEnum))
-	 this->inputs->AddInput(new BoolInput(MeshVertexonbedEnum,reCast<IssmBool>(iomodel->Data(MeshVertexonbedEnum)[io_index])));
+	 this->inputs->AddInput(new BoolInput(MeshVertexonbedEnum,reCast<bool>(iomodel->Data(MeshVertexonbedEnum)[io_index])));
 	if (iomodel->Data(MeshVertexonsurfaceEnum))
-	 this->inputs->AddInput(new BoolInput(MeshVertexonsurfaceEnum,reCast<IssmBool>(iomodel->Data(MeshVertexonsurfaceEnum)[io_index])));
+	 this->inputs->AddInput(new BoolInput(MeshVertexonsurfaceEnum,reCast<bool>(iomodel->Data(MeshVertexonsurfaceEnum)[io_index])));
 	if (iomodel->Data(MaskVertexonfloatingiceEnum))
-	 this->inputs->AddInput(new BoolInput(MaskVertexonfloatingiceEnum,reCast<IssmBool>(iomodel->Data(MaskVertexonfloatingiceEnum)[io_index])));
+	 this->inputs->AddInput(new BoolInput(MaskVertexonfloatingiceEnum,reCast<bool>(iomodel->Data(MaskVertexonfloatingiceEnum)[io_index])));
 	if (iomodel->Data(MaskVertexongroundediceEnum))
-	  this->inputs->AddInput(new BoolInput(MaskVertexongroundediceEnum,reCast<IssmBool>(iomodel->Data(MaskVertexongroundediceEnum)[io_index])));
+	  this->inputs->AddInput(new BoolInput(MaskVertexongroundediceEnum,reCast<bool>(iomodel->Data(MaskVertexongroundediceEnum)[io_index])));
 	if (analysis_type==DiagnosticHorizAnalysisEnum)
 	 this->inputs->AddInput(new IntInput(ApproximationEnum,reCast<IssmInt>(iomodel->Data(FlowequationVertexEquationEnum)[io_index])));
@@ -71,5 +71,5 @@
 	/*spc all nodes on water*/
 	if (!iomodel->Data(MaskVertexonwaterEnum)) _error_("iomodel->nodeonwater is NULL");
-	if (reCast<IssmBool>(iomodel->Data(MaskVertexonwaterEnum)[io_index])){
+	if (reCast<bool>(iomodel->Data(MaskVertexonwaterEnum)[io_index])){
 		for(k=1;k<=gsize;k++){
 			this->FreezeDof(k);
@@ -137,5 +137,5 @@
 			/*On a 3d mesh, we may have collapsed elements, hence dead nodes. Freeze them out: */
 			_assert_(iomodel->Data(MeshVertexonbedEnum));
-			if (!(reCast<IssmBool>(iomodel->Data(MeshVertexonbedEnum)[io_index]))){
+			if (!(reCast<bool>(iomodel->Data(MeshVertexonbedEnum)[io_index]))){
 				for(k=1;k<=gsize;k++){
 					this->FreezeDof(k);
@@ -166,5 +166,4 @@
 	_printLine_("   hvertex:     not displayed");
 	_printLine_("   inputs:      " << inputs);
-
 
 }
@@ -182,16 +181,8 @@
 	_printLine_("   inputs");
 
-
 }
 /*}}}*/
 /*FUNCTION Node::Id{{{*/
 int    Node::Id(void){ return id; }
-/*}}}*/
-/*FUNCTION Node::MyRank{{{*/
-int    Node::MyRank(void){ 
-	extern int my_rank;
-
-	return my_rank; 
-}
 /*}}}*/
 /*FUNCTION Node::ObjectEnum{{{*/
@@ -234,14 +225,4 @@
 
 } /*}}}*/
-/*FUNCTION Node::GetDofList1{{{*/
-int  Node::GetDofList1(void){
-
-	Vertex* vertex=NULL;
-
-	vertex=(Vertex*)this->hvertex->delivers();
-
-	return vertex->dof;
-}
-/*}}}*/
 /*FUNCTION Node::GetDofList{{{*/
 void  Node::GetDofList(int* outdoflist,int approximation_enum,int setenum){
@@ -249,5 +230,5 @@
 	int count=0;
 	int count2=0;
-		
+
 	if(approximation_enum==NoneApproximationEnum){
 		if(setenum==GsetEnum)for(i=0;i<this->indexing.gsize;i++) outdoflist[i]=indexing.gdoflist[i];
@@ -306,14 +287,4 @@
 }
 /*}}}*/
-/*FUNCTION Node::GetSidList{{{*/
-int  Node::GetSidList(void){
-
-	Vertex* vertex=NULL;
-
-	vertex=(Vertex*)this->hvertex->delivers();
-
-	return vertex->sid;
-}
-/*}}}*/
 /*FUNCTION Node::GetLocalDofList{{{*/
 void  Node::GetLocalDofList(int* outdoflist,int approximation_enum,int setenum){
@@ -321,5 +292,5 @@
 	int count=0;
 	int count2=0;
-		
+
 	if(approximation_enum==NoneApproximationEnum){
 		if(setenum==GsetEnum)for(i=0;i<this->indexing.gsize;i++) outdoflist[i]=i;
@@ -427,11 +398,21 @@
 }
 /*}}}*/
-/*FUNCTION Node::GetVertexDof {{{*/
-int   Node::GetVertexDof(void){
+/*FUNCTION Node::GetVertexPid{{{*/
+int   Node::GetVertexPid(void){
 
 	Vertex*  vertex=NULL;
 
 	vertex=(Vertex*)hvertex->delivers();
-	return vertex->dof;
+	return vertex->pid;
+}
+/*}}}*/
+/*FUNCTION Node::GetVertexSid{{{*/
+int  Node::GetVertexSid(void){
+
+	Vertex* vertex=NULL;
+
+	vertex=(Vertex*)this->hvertex->delivers();
+
+	return vertex->sid;
 }
 /*}}}*/
@@ -446,14 +427,4 @@
 /*}}}*/
 #endif
-/*FUNCTION Node::SetVertexDof {{{*/
-void   Node::SetVertexDof(int in_dof){
-
-	Vertex*  vertex=NULL;
-
-	vertex=(Vertex*)hvertex->delivers();
-	vertex->dof=in_dof;
-
-}
-/*}}}*/
 /*FUNCTION Node::InAnalysis{{{*/
 bool Node::InAnalysis(int in_analysis_type){
@@ -467,6 +438,4 @@
 void  Node::ApplyConstraint(int dof,IssmDouble value){
 
-	int index;
-
 	/*Dof should be added in the s set, describing which 
 	 * dofs are constrained to a certain value (dirichlet boundary condition*/
@@ -495,5 +464,5 @@
 		/*g set: */
 		pv_g->SetValue(indexing.gdoflist[i],gvalue,INS_VAL);
-		
+
 		/*f set: */
 		value=(IssmDouble)this->indexing.f_set[i];
@@ -505,5 +474,4 @@
 
 	}
-
 
 }
@@ -527,5 +495,5 @@
 			}
 		}
-		
+
 		/*Add values into constraint vector: */
 		ys->SetValues(this->indexing.ssize,this->indexing.sdoflist,values,INS_VAL);
@@ -535,5 +503,4 @@
 	xDelete<IssmDouble>(values);
 
-
 }
 /*}}}*/
@@ -560,5 +527,5 @@
 /*FUNCTION Node::FreezeDof{{{*/
 void  Node::FreezeDof(int dof){
-	
+
 	DofInSSet(dof-1); //with 0 displacement for this dof.
 
@@ -589,5 +556,5 @@
 	/*Get number of degrees of freedom in a node, for a certain set (g,f or s-set)
 	 *and for a certain approximation type: */
-	
+
 	int i;
 	int numdofs=0;
@@ -666,5 +633,5 @@
 /*FUNCTION Node::IsClone {{{*/
 int   Node::IsClone(){
-	
+
 	return indexing.clone;
 
@@ -695,5 +662,5 @@
 /*FUNCTION Node::IsFloating {{{*/
 int   Node::IsFloating(){
-	
+
 	bool onshelf;
 
@@ -887,10 +854,9 @@
 /*}}}*/
 
-/* DofObject routines:*/
+/* indexing routines:*/
 /*FUNCTION Node::DistributeDofs{{{*/
 void  Node::DistributeDofs(int* pdofcount,int setenum){
 
 	int i;
-	extern int my_rank;
 	int dofcount;
 
@@ -900,6 +866,5 @@
 	if(setenum==FsetEnum) this->indexing.InitSet(setenum);
 	if(setenum==SsetEnum) this->indexing.InitSet(setenum);
-	
-		
+
 	/*For clone nodfs, don't distribute dofs, we will get them from another cpu in UpdateCloneDofs!*/
 	if(indexing.clone){
@@ -908,5 +873,4 @@
 
 	/*This node should distribute dofs for setenum set (eg, f_set or s_set), go ahead: */
-
 	if(setenum==GsetEnum){
 		for(i=0;i<this->indexing.gsize;i++){
@@ -929,16 +893,13 @@
 	else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
 
-
 	/*Assign output pointers: */
 	*pdofcount=dofcount;
-
-}
-/*}}}*/
-/*FUNCTION Node::Off_setDofs{{{*/
+}
+/*}}}*/
+/*FUNCTION Node::OffsetDofs{{{*/
 void  Node::OffsetDofs(int dofcount,int setenum){
-	
+
 	int i;
-	extern int my_rank;
-	
+
 	if(indexing.clone){
 		/*This node is a clone, don't off_set the dofs!: */
@@ -963,14 +924,22 @@
 
 	int j;
-	extern int my_rank;
-	
+
 	/*Are we a clone? : */
-	if(indexing.clone)return;
+	if(indexing.clone) return;
 
 	/*Ok, we are not a clone, just plug our dofs into truedofs: */
-	if(setenum==GsetEnum)for(j=0;j<this->indexing.gsize;j++)  *(truedofs+ncols*sid+j)=indexing.gdoflist[j];
-	else if(setenum==FsetEnum)for(j=0;j<this->indexing.fsize;j++)  *(truedofs+ncols*sid+j)=indexing.fdoflist[j];
-	else if(setenum==SsetEnum)for(j=0;j<this->indexing.ssize;j++)  *(truedofs+ncols*sid+j)=indexing.sdoflist[j];
-	else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
+	switch(setenum){
+		case GsetEnum:
+			for(j=0;j<this->indexing.gsize;j++) truedofs[ncols*sid+j]=indexing.gdoflist[j];
+			break;
+		case FsetEnum:
+			for(j=0;j<this->indexing.fsize;j++) truedofs[ncols*sid+j]=indexing.fdoflist[j];
+			break;
+		case SsetEnum:
+			for(j=0;j<this->indexing.ssize;j++) truedofs[ncols*sid+j]=indexing.sdoflist[j];
+			break;
+		default:
+			_error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
+	}
 
 }
@@ -980,17 +949,23 @@
 
 	int j;
-	extern int my_rank;
-	
+
 	/*If we are not a clone, don't update, we already have dofs!: */
-	if(indexing.clone==0)return;
-
+	if(!indexing.clone)return;
 
 	/*Ok, we are a clone node, but we did not create the dofs for this node.
-	 *      * Therefore, our doflist is garbage right now. Go pick it up in the alltruedofs: */
-	if(setenum==GsetEnum)for(j=0;j<this->indexing.gsize;j++) indexing.gdoflist[j]=*(alltruedofs+ncols*sid+j);
-	else if(setenum==FsetEnum)for(j=0;j<this->indexing.fsize;j++) indexing.fdoflist[j]=*(alltruedofs+ncols*sid+j);
-	else if(setenum==SsetEnum)for(j=0;j<this->indexing.ssize;j++) indexing.sdoflist[j]=*(alltruedofs+ncols*sid+j);
-	else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
-
+	 *Therefore, our doflist is garbage right now. Go pick it up in the alltruedofs: */
+	switch(setenum){
+		case GsetEnum:
+			for(j=0;j<this->indexing.gsize;j++) indexing.gdoflist[j]=alltruedofs[ncols*sid+j];
+			break;
+		case FsetEnum:
+			for(j=0;j<this->indexing.fsize;j++) indexing.fdoflist[j]=alltruedofs[ncols*sid+j];
+			break;
+		case SsetEnum:
+			for(j=0;j<this->indexing.ssize;j++) indexing.sdoflist[j]=alltruedofs[ncols*sid+j];
+			break;
+		default:
+			_error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
+	}
 }
 /*}}}*/
@@ -998,15 +973,17 @@
 void  Node::SetClone(int* minranks){
 
-	extern int my_rank;
+	int my_rank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	if (minranks[sid]==my_rank){
-		indexing.clone=0;
+		indexing.clone=false;
 	}
 	else{
 		/*!there is a cpu with lower rank that has the same node, 
 		therefore, I am a clone*/
-		indexing.clone=1; 	
-	}
-
-}
-/*}}}*/
+		indexing.clone=true;	
+	}
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/objects/Node.h
===================================================================
--- issm/trunk/src/c/classes/objects/Node.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Node.h	(revision 13975)
@@ -25,12 +25,12 @@
 	public: 
 
-		int	    id;  //unique arbitrary id.
-		int     sid; //sid for "serial" id, ie the rank of this node in the nodes dataset, if the dataset was serial on 1 cpu.
-				
-		DofIndexing    indexing;
-		Hook*          hvertex;
-		Inputs*        inputs; //properties of this node
-		int            analysis_type;
-		IssmDouble         coord_system[3][3];
+		int id;    //unique arbitrary id.
+		int sid;   //"serial" id (rank of this node if the dataset was serial on 1 cpu)
+
+		DofIndexing  indexing;
+		Hook        *hvertex;
+		Inputs      *inputs;               //properties of this node
+		int          analysis_type;
+		IssmDouble   coord_system[3][3];
 
 		/*Node constructors, destructors {{{*/
@@ -40,13 +40,11 @@
 		/*}}}*/
 		/*Object virtual functions definitions:{{{ */
-		void  Echo();
-		void  DeepEcho();
-		int   Id(); 
-		int   MyRank();
-		int   ObjectEnum();
-		Object* copy(){_error_("Not implemented yet (similar to Elements)");};
+		void    Echo();
+		void    DeepEcho();
+		int     Id();
+		int     ObjectEnum();
+		Object *copy()        {_error_("Not implemented yet (similar to Elements)"); };
 		/*}}}*/
 		/*Update virtual functions definitions: {{{*/
-		
 		void  InputUpdateFromVector(IssmDouble* vector, int name, int type);
 		void  InputUpdateFromVector(int* vector, int name, int type);
@@ -67,10 +65,7 @@
 		void   SetCurrentConfiguration(DataSet* nodes,Vertices* vertices);
 		int    Sid(void); 
-		int    GetVertexDof(void);
-		int    GetVertexId(void);
 #ifdef _HAVE_DIAGNOSTIC_
 		void   GetCoordinateSystem(IssmDouble* coord_system_out);
 #endif
-		void   SetVertexDof(int in_dof);
 		bool   InAnalysis(int analysis_type);
 		int    GetApproximation();
@@ -86,6 +81,7 @@
 		void   GetDofList(int* poutdoflist,int approximation_enum,int setenum);
 		void   GetLocalDofList(int* poutdoflist,int approximation_enum,int setenum);
-		int    GetDofList1(void);
-		int    GetSidList(void);
+		int    GetVertexId(void);
+		int    GetVertexPid(void);
+		int    GetVertexSid(void);
 		IssmDouble GetX();
 		IssmDouble GetY();
@@ -100,7 +96,4 @@
 		void   VecMerge(Vector<IssmDouble>* ug, IssmDouble* vector_serial,int setenum);
 		void   VecReduce(Vector<IssmDouble>* vector, IssmDouble* ug_serial,int setnum);
-		
-		/*}}}*/
-		/*Dof Object routines {{{*/
 		void  DistributeDofs(int* pdofcount,int setenum);
 		void  OffsetDofs(int dofcount,int setenum);
Index: issm/trunk/src/c/classes/objects/Object.h
===================================================================
--- issm/trunk/src/c/classes/objects/Object.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Object.h	(revision 13975)
@@ -7,5 +7,4 @@
  * DataSet.
  */
-
 
 #ifndef _OBJECT_H_
@@ -20,5 +19,4 @@
 		virtual void  DeepEcho()=0;
 		virtual int   Id()=0;
-		virtual int   MyRank()=0;
 		virtual int   ObjectEnum()=0;
 		virtual Object* copy()=0;
Index: issm/trunk/src/c/classes/objects/Options/GenericOption.h
===================================================================
--- issm/trunk/src/c/classes/objects/Options/GenericOption.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Options/GenericOption.h	(revision 13975)
@@ -29,10 +29,10 @@
 	public:
 
-		char* name;
-		OptionType value;
+		char       *name;
+		OptionType  value;
 
-		int   numel; //in case OptionType is an array
-		int   ndims; //in case OptionType is a multi-dimensional array: */
-		int*  size;
+		int         numel;   //in case OptionType is an array
+		int         ndims;   //in case OptionType is a multi-dimensional array: */
+		int        *size;
 
 		/*GenericOption constructors, destructors*/
@@ -43,5 +43,4 @@
 			ndims =0;
 			size  =NULL;
-
 
 		} /*}}}*/
@@ -81,8 +80,7 @@
 		} /*}}}*/
 		int   Id(){_error_("Not implemented yet");};
-		int   MyRank(){_error_("Not implemented yet");};
 		int   ObjectEnum(){return GenericOptionEnum;};
 		Object* copy(){_error_("Not implemented yet");};
-		
+
 		/*GenericOption functions: */
 		char* Name(){return name;};
@@ -93,5 +91,5 @@
 };
 
-#ifdef _HAVE_ADOLC_ //We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization. 
+#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)  //We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization. 
 template <> inline void GenericOption<IssmPDouble*>::Get(IssmPDouble** pvalue){ /*{{{*/
 
@@ -115,9 +113,6 @@
 template <> inline void GenericOption<char*>::Get(char** pvalue){ /*{{{*/
 
-	char* outstring=NULL;
-	int   stringsize;
-
-	stringsize=strlen(this->value)+1;
-	outstring=xNew<char>(stringsize);
+	int   stringsize=strlen(this->value)+1;
+	char* outstring=xNew<char>(stringsize);
 	xMemCpy<char>(outstring,this->value,stringsize);
 
Index: issm/trunk/src/c/classes/objects/Options/Option.h
===================================================================
--- issm/trunk/src/c/classes/objects/Options/Option.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Options/Option.h	(revision 13975)
@@ -18,18 +18,15 @@
 	public:
 
-		
-		/*Option constructors, destructors {{{*/
+		/*Option constructors, destructors*/
 		Option(){};
 		~Option(){};
-		/*}}}*/
-		/*Object virtual functions definitions:{{{*/
+
+		/*Object virtual functions definitions*/
 		virtual void  Echo()= 0;
 		virtual void  DeepEcho()= 0;
 		virtual void  DeepEcho(char  *indent)=0;
 		int           Id(){_error_("Not implemented yet"); };
-		int           MyRank(){_error_("Not implemented yet"); };
 		int           ObjectEnum(){return OptionEnum;              };
 		Object       *copy(){_error_("Not implemented yet"); };
-		/*}}}*/
 
 		/*virtual functions: */
@@ -41,3 +38,2 @@
 };
 #endif  /* _OPTIONOBJECT_H */
-
Index: issm/trunk/src/c/classes/objects/Params/BoolParam.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Params/BoolParam.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Params/BoolParam.cpp	(revision 13975)
@@ -26,6 +26,6 @@
 }
 /*}}}*/
-/*FUNCTION BoolParam::BoolParam(int enum_type,IssmBool value){{{*/
-BoolParam::BoolParam(int in_enum_type,IssmBool in_value){
+/*FUNCTION BoolParam::BoolParam(int enum_type,bool value){{{*/
+BoolParam::BoolParam(int in_enum_type,bool in_value){
 
 	enum_type=in_enum_type;
@@ -56,10 +56,4 @@
 int    BoolParam::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION BoolParam::MyRank{{{*/
-int    BoolParam::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION BoolParam::ObjectEnum{{{*/
 int BoolParam::ObjectEnum(void){
@@ -71,5 +65,5 @@
 /*FUNCTION BoolParam::copy{{{*/
 Object* BoolParam::copy() {
-	
+
 	return new BoolParam(this->enum_type,this->value);
 
Index: issm/trunk/src/c/classes/objects/Params/BoolParam.h
===================================================================
--- issm/trunk/src/c/classes/objects/Params/BoolParam.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Params/BoolParam.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for triavertexinput object
  */
-
 
 #ifndef _BOOLPARAM_H_
@@ -25,9 +24,9 @@
 		/*just hold 3 values for 3 vertices: */
 		int enum_type;
-		IssmBool value;
+		bool value;
 
 		/*BoolParam constructors, destructors: {{{*/
 		BoolParam();
-		BoolParam(int enum_type,IssmBool value);
+		BoolParam(int enum_type,bool value);
 		~BoolParam();
 		/*}}}*/
@@ -36,5 +35,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
@@ -56,4 +54,5 @@
 		void  GetParameterValue(Matrix<IssmDouble>** pmat){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a Mat");}
 		void  GetParameterValue(FILE** pfid){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a FILE");}
+		void  GetParameterValue(DataSet** pdataset){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a DataSet");}
 
 		void  SetValue(bool boolean){this->value=boolean;}
@@ -71,5 +70,5 @@
 		void  SetValue(IssmDouble** array, int M, int* mdim_array, int* ndim_array){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold an array of matrices");}
 		void  UnitConversion(int direction_enum);
-		
+
 		void GetParameterName(char**pname);
 		/*}}}*/
Index: issm/trunk/src/c/classes/objects/Params/DataSetParam.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Params/DataSetParam.cpp	(revision 13975)
+++ issm/trunk/src/c/classes/objects/Params/DataSetParam.cpp	(revision 13975)
@@ -0,0 +1,89 @@
+/*!\file DataSetParam.c
+ * \brief: implementation of the DataSetParam object
+ */
+
+/*header files: */
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*DataSetParam constructors and destructor*/
+/*FUNCTION DataSetParam::DataSetParam(){{{*/
+DataSetParam::DataSetParam(){
+	value=NULL;
+	return;
+}
+/*}}}*/
+/*FUNCTION DataSetParam::DataSetParam(int enum_type,DataSet *value){{{*/
+DataSetParam::DataSetParam(int in_enum_type,DataSet* in_value){
+
+	enum_type=in_enum_type;
+	value=in_value->Copy();;
+}
+/*}}}*/
+/*FUNCTION DataSetParam::~DataSetParam(){{{*/
+DataSetParam::~DataSetParam(){
+	delete value;
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION DataSetParam::Echo {{{*/
+void DataSetParam::Echo(void){
+	this->DeepEcho();
+}
+/*}}}*/
+/*FUNCTION DataSetParam::DeepEcho{{{*/
+void DataSetParam::DeepEcho(void){
+
+	_printLine_("DataSetParam:");
+	_printLine_("   enum:  " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	this->value->Echo();
+}
+/*}}}*/
+/*FUNCTION DataSetParam::Id{{{*/
+int    DataSetParam::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION DataSetParam::ObjectEnum{{{*/
+int DataSetParam::ObjectEnum(void){
+
+	return DataSetParamEnum;
+
+}
+/*}}}*/
+/*FUNCTION DataSetParam::copy{{{*/
+Object* DataSetParam::copy() {
+
+	return new DataSetParam(this->enum_type,this->value);
+
+}
+/*}}}*/
+
+/*DataSetParam virtual functions definitions: */
+/*FUNCTION DataSetParam::GetParameterName{{{*/
+void DataSetParam::GetParameterName(char**pname){
+	EnumToStringx(pname,this->enum_type);
+}
+/*}}}*/
+/*FUNCTION DataSetParam::UnitConversion{{{*/
+void  DataSetParam::UnitConversion(int direction_enum){
+	/*do nothing, no unit conversion*/
+}
+/*}}}*/
+/*FUNCTION DataSetParam::GetParameterValue{{{*/
+void DataSetParam::GetParameterValue(DataSet** pdataset){
+	*pdataset=value->Copy();
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/objects/Params/DataSetParam.h
===================================================================
--- issm/trunk/src/c/classes/objects/Params/DataSetParam.h	(revision 13975)
+++ issm/trunk/src/c/classes/objects/Params/DataSetParam.h	(revision 13975)
@@ -0,0 +1,78 @@
+/*! \file DataSetParam.h 
+ *  \brief: header file for triavertexinput object
+ */
+
+#ifndef _DATASETPARAM_H_
+#define _DATASETPARAM_H_
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Param.h"
+#include "../../../include/include.h"
+#include "../../../shared/shared.h"
+/*}}}*/
+
+class DataSetParam: public Param{
+
+	private: 
+		int   enum_type;
+		DataSet* value;
+
+	public:
+		/*DataSetParam constructors, destructors: {{{*/
+		DataSetParam();
+		DataSetParam(int enum_type,DataSet* dataset);
+		~DataSetParam();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*Param vritual function definitions: {{{*/
+		int   InstanceEnum(){return enum_type;}
+		void  GetParameterValue(bool* pbool){  _error_("Param "<< EnumToStringx(enum_type) << " cannot return a bool");}
+		void  GetParameterValue(int* pinteger){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble");}
+		void  GetParameterValue(int** pintarray,int* pM){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble");}
+		void  GetParameterValue(int** pintarray,int* pM,int* pN){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble");}
+		void  GetParameterValue(IssmDouble* pIssmDouble){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble");}
+		void  GetParameterValue(IssmDouble* pdouble,IssmDouble time){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble for a given time");}
+		void  GetParameterValue(FILE** pfile){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a file pointer");}
+		void  GetParameterValue(char** pstring){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a string");}
+		void  GetParameterValue(char*** pstringarray,int* pM){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a string array");}
+		void  GetParameterValue(IssmDouble** pIssmDoublearray,int* pM){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble array");}
+		void  GetParameterValue(IssmDouble** pIssmDoublearray,int* pM, int* pN){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a IssmDouble array");}
+		void  GetParameterValue(IssmDouble*** parray, int* pM,int** pmdims, int** pndims){_error_("DataSet param of enum " << enum_type << " (" << EnumToStringx(enum_type) << ") cannot return a matrix array");}
+		void  GetParameterValue(Vector<IssmDouble>** pvec){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a Vec");}
+		void  GetParameterValue(Matrix<IssmDouble>** pmat){_error_("Param "<< EnumToStringx(enum_type) << " cannot return a Mat");}
+		void  GetParameterValue(DataSet** pdataset);
+
+		void  SetValue(bool boolean){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a string");}
+		void  SetValue(int integer){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a string");}
+		void  SetValue(IssmDouble scalar){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a string");}
+		void  SetValue(char* string){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a string");}
+		void  SetValue(FILE* fid){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a file pointer");}
+		void  SetValue(char** stringarray,int M){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a string array");}
+		void  SetValue(IssmDouble* IssmDoublearray,int M){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a IssmDouble array");}
+		void  SetValue(IssmDouble* pIssmDoublearray,int M,int N){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a IssmDouble array");}
+		void  SetValue(int* intarray,int M){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a int array");}
+		void  SetValue(int* pintarray,int M,int N){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a int array");}
+		void  SetValue(Vector<IssmDouble>* vec){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a Vec");}
+		void  SetValue(Matrix<IssmDouble>* mat){_error_("Param "<< EnumToStringx(enum_type) << " cannot hold a Mat");}
+		void  SetValue(DataSet* dataset){_error_("DataSet param of enum " << enum_type << " (" << EnumToStringx(enum_type) << ") cannot hold a DataSet yet");}
+		void  SetValue(IssmDouble** array, int M, int* mdim_array, int* ndim_array){_error_("DataSet param of enum " << enum_type << " (" << EnumToStringx(enum_type) << ") cannot hold an array of matrices");}
+		void  UnitConversion(int direction_enum);
+
+		void GetParameterName(char**pname);
+
+		/*}}}*/
+};
+#endif  /* _INTPARAM_H */
